var state=Array(4);
var count=Array(2);
var a,b,c,d;
var context_buffer=Array(16);
var digest=Array(4);

function hex_md5(s)
{ 
	md5_init();
	return binl2hex(core_md5(str2binl(s), s.length * 8));
}

function md5_init()
{
    count[0]=0;
    count[1]=0;
    state[0]=0x67452301;
    state[1]=0xefcdab89;
    state[2]=0x98badcfe;
    state[3]=0x10325476;
}

function core_md5(x, len)
{
	x[len >> 5] |= 0x80 << ((len) % 32);
	x[(((len + 64) >>> 9) << 4) + 14] = len;
	a=state[0];
	b=state[1];
	c=state[2];
	d=state[3];
	for(var i = 0; i < x.length; i += 16) {
		var olda=a;
		var oldb=b;
		var oldc=c;
		var oldd=d;
		md5_rotate(x,i);
		a=safe_add(a,olda);
		b=safe_add(b,oldb);
		c=safe_add(c,oldc);
		d=safe_add(d,oldd);
	}
	return Array(a,b,c,d);
}

function md5_rotate(x, i)
{
	a=md5_ff(a,b,c,d,x[i+ 0],7 ,0xd76aa478);
	d=md5_ff(d,a,b,c,x[i+ 1],12,0xe8c7b756);
	c=md5_ff(c,d,a,b,x[i+ 2],17,0x242070db);
	b=md5_ff(b,c,d,a,x[i+ 3],22,0xc1bdceee);
	a=md5_ff(a,b,c,d,x[i+ 4],7 ,0xf57c0faf);
	d=md5_ff(d,a,b,c,x[i+ 5],12,0x4787c62a);
	c=md5_ff(c,d,a,b,x[i+ 6],17,0xa8304613);
	b=md5_ff(b,c,d,a,x[i+ 7],22,0xfd469501);
	a=md5_ff(a,b,c,d,x[i+ 8],7 ,0x698098d8);
	d=md5_ff(d,a,b,c,x[i+ 9],12,0x8b44f7af);
	c=md5_ff(c,d,a,b,x[i+10],17,0xffff5bb1);
	b=md5_ff(b,c,d,a,x[i+11],22,0x895cd7be);
	a=md5_ff(a,b,c,d,x[i+12],7 ,0x6b901122);
	d=md5_ff(d,a,b,c,x[i+13],12,0xfd987193);
	c=md5_ff(c,d,a,b,x[i+14],17,0xa679438e);
	b=md5_ff(b,c,d,a,x[i+15],22,0x49b40821);

	a=md5_gg(a,b,c,d,x[i+ 1],5 ,0xf61e2562);
	d=md5_gg(d,a,b,c,x[i+ 6],9 ,0xc040b340);
	c=md5_gg(c,d,a,b,x[i+11],14,0x265e5a51);
	b=md5_gg(b,c,d,a,x[i+ 0],20,0xe9b6c7aa);
	a=md5_gg(a,b,c,d,x[i+ 5],5 ,0xd62f105d);
	d=md5_gg(d,a,b,c,x[i+10],9 ,0x2441453);
	c=md5_gg(c,d,a,b,x[i+15],14,0xd8a1e681);
	b=md5_gg(b,c,d,a,x[i+ 4],20,0xe7d3fbc8);
	a=md5_gg(a,b,c,d,x[i+ 9],5 ,0x21e1cde6);
	d=md5_gg(d,a,b,c,x[i+14],9 ,0xc33707d6);
	c=md5_gg(c,d,a,b,x[i+ 3],14,0xf4d50d87);
	b=md5_gg(b,c,d,a,x[i+ 8],20,0x455a14ed);
	a=md5_gg(a,b,c,d,x[i+13],5 ,0xa9e3e905);
	d=md5_gg(d,a,b,c,x[i+ 2],9 ,0xfcefa3f8);
	c=md5_gg(c,d,a,b,x[i+ 7],14,0x676f02d9);
	b=md5_gg(b,c,d,a,x[i+12],20,0x8d2a4c8a);

	a=md5_hh(a,b,c,d,x[i+ 5],4 ,0xfffa3942);
	d=md5_hh(d,a,b,c,x[i+ 8],11,0x8771f681);
	c=md5_hh(c,d,a,b,x[i+11],16,0x6d9d6122);
	b=md5_hh(b,c,d,a,x[i+14],23,0xfde5380c);
	a=md5_hh(a,b,c,d,x[i+ 1],4 ,0xa4beea44);
	d=md5_hh(d,a,b,c,x[i+ 4],11,0x4bdecfa9);
	c=md5_hh(c,d,a,b,x[i+ 7],16,0xf6bb4b60);
	b=md5_hh(b,c,d,a,x[i+10],23,0xbebfbc70);
	a=md5_hh(a,b,c,d,x[i+13],4 ,0x289b7ec6);
	d=md5_hh(d,a,b,c,x[i+ 0],11,0xeaa127fa);
	c=md5_hh(c,d,a,b,x[i+ 3],16,0xd4ef3085);
	b=md5_hh(b,c,d,a,x[i+ 6],23,0x4881d05);
	a=md5_hh(a,b,c,d,x[i+ 9],4 ,0xd9d4d039);
	d=md5_hh(d,a,b,c,x[i+12],11,0xe6db99e5);
	c=md5_hh(c,d,a,b,x[i+15],16,0x1fa27cf8);
	b=md5_hh(b,c,d,a,x[i+ 2],23,0xc4ac5665);

	a=md5_ii(a,b,c,d,x[i+ 0],6 ,0xf4292244);
	d=md5_ii(d,a,b,c,x[i+ 7],10,0x432aff97);
	c=md5_ii(c,d,a,b,x[i+14],15,0xab9423a7);
	b=md5_ii(b,c,d,a,x[i+ 5],21,0xfc93a039);
	a=md5_ii(a,b,c,d,x[i+12],6 ,0x655b59c3);
	d=md5_ii(d,a,b,c,x[i+ 3],10,0x8f0ccc92);
	c=md5_ii(c,d,a,b,x[i+10],15,0xffeff47d);
	b=md5_ii(b,c,d,a,x[i+ 1],21,0x85845dd1);
	a=md5_ii(a,b,c,d,x[i+ 8],6 ,0x6fa87e4f);
	d=md5_ii(d,a,b,c,x[i+15],10,0xfe2ce6e0);
	c=md5_ii(c,d,a,b,x[i+ 6],15,0xa3014314);
	b=md5_ii(b,c,d,a,x[i+13],21,0x4e0811a1);
	a=md5_ii(a,b,c,d,x[i+ 4],6 ,0xf7537e82);
	d=md5_ii(d,a,b,c,x[i+11],10,0xbd3af235);
	c=md5_ii(c,d,a,b,x[i+ 2],15,0x2ad7d2bb);
	b=md5_ii(b,c,d,a,x[i+ 9],21,0xeb86d391);
}

function md5_cmn(q, a, b, x, s, t)
{
	return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
	return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
	return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
	return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
	return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

function safe_add(x, y)
{
	var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	return (msw << 16) | (lsw & 0xFFFF);
}

function bit_rol(num, cnt)
{
	return (num << cnt) | (num >>> (32 - cnt));
}

function str2binl(str)
{
	var bin = Array();
	var mask = (1 << 8) - 1;
	for(var i = 0; i < str.length * 8; i += 8)
		bin[i>>5] |= (str.charCodeAt(i / 8) & mask) << (i%32);
	return bin;
}

function binl2hex(binarray)
{
	var hex_tab = 0 ? "0123456789ABCDEF" : "0123456789abcdef";
	var str = "";
	for(var i = 0; i < binarray.length * 4; i++)
		str += hex_tab.charAt((binarray[i>>2] >> ((i%4)*8+4)) & 0xF) + hex_tab.charAt((binarray[i>>2] >> ((i%4)*8  )) & 0xF);
	return str;
}

function md5_transform(block)
{
	a=state[0];
	b=state[1];
	c=state[2];
	d=state[3];
	md5_rotate(block,0);
	state[0] +=a;
	state[1] +=b;
	state[2] +=c;
	state[3] +=d;
}

function md5_update(input,inputLen)
{
    var i,idx,j;
    var partLen;
    var tmpbuffer=Array(16);

    idx=(count[0] >> 3) & 0x3F;
    count[0] += (inputLen << 3);
    if(count[0] < (inputLen << 3))
        count[1]++;
    count[1] +=inputLen >> 29;
    partLen = 64 - idx;
    if (inputLen >= partLen) {
        for(j=0;j<partLen;j++) {
        	context_buffer[(idx+j)>>2] &=~(0x000000ff<<(((idx+j)%4)*8));
        	context_buffer[(idx+j)>>2] |=((input[j>>2]>>((j%4)*8)) & 0x000000ff)<<(((idx+j)%4)*8);
        }
        md5_transform(context_buffer);
        for(i=partLen; i + 63 < inputLen; i += 64) {
	        for(j=0;j<partLen;j++) {
   		     	tmpbuffer[j>>2] &=~(0x000000ff<<((j%4)*8));
    	    	tmpbuffer[j>>2] |=((input[(j+i)>>2]>>(((j+i)%4)*8)) & 0x000000ff)<<((j%4)*8);
        	}
            md5_transform(tmpbuffer);
        }
        idx = 0;
    }
    else
        i = 0;
    for(j=0;j<inputLen-i;j++) {
       	context_buffer[(idx+j)>>2] &=~(0x000000ff<<((idx+j)%4)*8);
       	context_buffer[(idx+j)>>2] |=((input[(j+i)>>2]>>(((j+i)%4)*8)) & 0x000000ff)<<(((idx+j)%4)*8);
    }
}

function md5_final()
{
    var bits=Array(2);
    var idx;
    var padLen;
    var PADDING=Array(16);
    var i;

	bits[0]=count[0];
	bits[1]=count[1];
	PADDING[0]=0x80;
	for(i=1;i<16;i++)
		PADDING[i]=0;
    idx = (count[0] >> 3) & 0x3f;
    padLen = (idx < 56) ? (56 - idx) : (120 - idx);
    md5_update(PADDING, padLen);
    md5_update(bits, 8);
    digest[0]=state[0];
    digest[1]=state[1];
    digest[2]=state[2];
    digest[3]=state[3];
}

function md5_key(password, passwordlen)
{
	var i=0,j=0;
	var password_buf=Array(17);
	var password_index=0;
	var count=0;
	var eID="101396";
	
	md5_init();
	while(count<1048576) {
		for(i=0;i<16;i++) {
			password_buf[i]=password.charCodeAt(password_index++ % passwordlen);
			password_buf[i] |=(password.charCodeAt(password_index++ % passwordlen))<<8;
			password_buf[i] |=(password.charCodeAt(password_index++ % passwordlen))<<16;
			password_buf[i] |=(password.charCodeAt(password_index++ % passwordlen))<<24;
		}
		md5_update(password_buf,64);
		count +=64;
	}
	md5_final();
	for(i=0;i<17;i++)
		password_buf[i]=0;
	j=0;
	for(i=0;i<4;i++)
		password_buf[j++]=digest[i];
	for(i=0;i<eID.length>>2;i++) {
		password_buf[j] |=eID.charCodeAt(i*4);
		password_buf[j] |=(eID.charCodeAt(i*4+1))<<8;
		password_buf[j] |=(eID.charCodeAt(i*4+2))<<16;
		password_buf[j++] |=(eID.charCodeAt(i*4+3))<<24;
	}
	for(i=0;i<eID.length%4;i++)
		password_buf[j] |=(eID.charCodeAt((eID.length>>2)*4+i))<<(8*i);
	j++;
	for(i=0;i<4;i++) {
		password_buf[j-1] |=digest[i]<<(8*(eID.length%4));
		password_buf[j]=digest[i]>>>(8*(4-(eID.length%4)));
		j++;
	}
	md5_init();
	md5_update(password_buf,32+eID.length);
	md5_final();
	return binl2hex(digest);
}
